/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.med_equip;

import org.apache.dubbo.common.stream.StreamObserver;
import org.apache.dubbo.common.URL;
import org.apache.dubbo.rpc.Invoker;
import org.apache.dubbo.rpc.PathResolver;
import org.apache.dubbo.rpc.RpcException;
import org.apache.dubbo.rpc.ServerService;
import org.apache.dubbo.rpc.TriRpcStatus;
import org.apache.dubbo.rpc.model.MethodDescriptor;
import org.apache.dubbo.rpc.model.ServiceDescriptor;
import org.apache.dubbo.rpc.model.StubMethodDescriptor;
import org.apache.dubbo.rpc.model.StubServiceDescriptor;
import org.apache.dubbo.rpc.stub.BiStreamMethodHandler;
import org.apache.dubbo.rpc.stub.ServerStreamMethodHandler;
import org.apache.dubbo.rpc.stub.StubInvocationUtil;
import org.apache.dubbo.rpc.stub.StubInvoker;
import org.apache.dubbo.rpc.stub.StubMethodHandler;
import org.apache.dubbo.rpc.stub.StubSuppliers;
import org.apache.dubbo.rpc.stub.UnaryStubMethodHandler;

import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public final class DubboMedEquipServiceTriple {

    public static final String SERVICE_NAME = MedEquipService.SERVICE_NAME;

    private static final StubServiceDescriptor serviceDescriptor = new StubServiceDescriptor(SERVICE_NAME,MedEquipService.class);

    static {
        org.apache.dubbo.rpc.protocol.tri.service.SchemaDescriptorRegistry.addSchemaDescriptor(SERVICE_NAME,MedEquipProto.getDescriptor());
        StubSuppliers.addSupplier(SERVICE_NAME, DubboMedEquipServiceTriple::newStub);
        StubSuppliers.addSupplier(MedEquipService.JAVA_SERVICE_NAME,  DubboMedEquipServiceTriple::newStub);
        StubSuppliers.addDescriptor(SERVICE_NAME, serviceDescriptor);
        StubSuppliers.addDescriptor(MedEquipService.JAVA_SERVICE_NAME, serviceDescriptor);
    }

    @SuppressWarnings("all")
    public static MedEquipService newStub(Invoker<?> invoker) {
        return new MedEquipServiceStub((Invoker<MedEquipService>)invoker);
    }

    /**
         * <pre>
         *  事件类型：1-24小时归还设备提醒
         * </pre>
         */
    private static final StubMethodDescriptor triggerScheduledJobMethod = new StubMethodDescriptor("triggerScheduledJob",
    com.ywt.gapi.med_equip.TriggerScheduledJobRequest.class, com.ywt.gapi.med_equip.TriggerScheduledJobResponse.class, serviceDescriptor, MethodDescriptor.RpcType.UNARY,
    obj -> ((Message) obj).toByteArray(), obj -> ((Message) obj).toByteArray(), com.ywt.gapi.med_equip.TriggerScheduledJobRequest::parseFrom,
    com.ywt.gapi.med_equip.TriggerScheduledJobResponse::parseFrom);

    private static final StubMethodDescriptor triggerScheduledJobAsyncMethod = new StubMethodDescriptor("triggerScheduledJob",
    com.ywt.gapi.med_equip.TriggerScheduledJobRequest.class, CompletableFuture.class, serviceDescriptor, MethodDescriptor.RpcType.UNARY,
    obj -> ((Message) obj).toByteArray(), obj -> ((Message) obj).toByteArray(), com.ywt.gapi.med_equip.TriggerScheduledJobRequest::parseFrom,
    com.ywt.gapi.med_equip.TriggerScheduledJobResponse::parseFrom);

    private static final StubMethodDescriptor triggerScheduledJobProxyAsyncMethod = new StubMethodDescriptor("triggerScheduledJobAsync",
    com.ywt.gapi.med_equip.TriggerScheduledJobRequest.class, com.ywt.gapi.med_equip.TriggerScheduledJobResponse.class, serviceDescriptor, MethodDescriptor.RpcType.UNARY,
    obj -> ((Message) obj).toByteArray(), obj -> ((Message) obj).toByteArray(), com.ywt.gapi.med_equip.TriggerScheduledJobRequest::parseFrom,
    com.ywt.gapi.med_equip.TriggerScheduledJobResponse::parseFrom);





    public static class MedEquipServiceStub implements MedEquipService{
        private final Invoker<MedEquipService> invoker;

        public MedEquipServiceStub(Invoker<MedEquipService> invoker) {
            this.invoker = invoker;
        }

            /**
         * <pre>
         *  事件类型：1-24小时归还设备提醒
         * </pre>
         */
        @Override
        public com.ywt.gapi.med_equip.TriggerScheduledJobResponse triggerScheduledJob(com.ywt.gapi.med_equip.TriggerScheduledJobRequest request){
            return StubInvocationUtil.unaryCall(invoker, triggerScheduledJobMethod, request);
        }

        public CompletableFuture<com.ywt.gapi.med_equip.TriggerScheduledJobResponse> triggerScheduledJobAsync(com.ywt.gapi.med_equip.TriggerScheduledJobRequest request){
            return StubInvocationUtil.unaryCall(invoker, triggerScheduledJobAsyncMethod, request);
        }

            /**
         * <pre>
         *  事件类型：1-24小时归还设备提醒
         * </pre>
         */
        @Override
        public void triggerScheduledJob(com.ywt.gapi.med_equip.TriggerScheduledJobRequest request, StreamObserver<com.ywt.gapi.med_equip.TriggerScheduledJobResponse> responseObserver){
            StubInvocationUtil.unaryCall(invoker, triggerScheduledJobMethod , request, responseObserver);
        }



    }

    public static abstract class MedEquipServiceImplBase implements MedEquipService, ServerService<MedEquipService> {

        private <T, R> BiConsumer<T, StreamObserver<R>> syncToAsync(java.util.function.Function<T, R> syncFun) {
            return new BiConsumer<T, StreamObserver<R>>() {
                @Override
                public void accept(T t, StreamObserver<R> observer) {
                    try {
                        R ret = syncFun.apply(t);
                        observer.onNext(ret);
                        observer.onCompleted();
                    } catch (Throwable e) {
                        observer.onError(e);
                    }
                }
            };
        }

        @Override
        public final Invoker<MedEquipService> getInvoker(URL url) {
            PathResolver pathResolver = url.getOrDefaultFrameworkModel()
            .getExtensionLoader(PathResolver.class)
            .getDefaultExtension();
            Map<String,StubMethodHandler<?, ?>> handlers = new HashMap<>();

            pathResolver.addNativeStub( "/" + SERVICE_NAME + "/triggerScheduledJob" );
            pathResolver.addNativeStub( "/" + SERVICE_NAME + "/triggerScheduledJobAsync" );

            BiConsumer<com.ywt.gapi.med_equip.TriggerScheduledJobRequest, StreamObserver<com.ywt.gapi.med_equip.TriggerScheduledJobResponse>> triggerScheduledJobFunc = this::triggerScheduledJob;
            handlers.put(triggerScheduledJobMethod.getMethodName(), new UnaryStubMethodHandler<>(triggerScheduledJobFunc));
            BiConsumer<com.ywt.gapi.med_equip.TriggerScheduledJobRequest, StreamObserver<com.ywt.gapi.med_equip.TriggerScheduledJobResponse>> triggerScheduledJobAsyncFunc = syncToAsync(this::triggerScheduledJob);
            handlers.put(triggerScheduledJobProxyAsyncMethod.getMethodName(), new UnaryStubMethodHandler<>(triggerScheduledJobAsyncFunc));




            return new StubInvoker<>(this, url, MedEquipService.class, handlers);
        }


        @Override
        public com.ywt.gapi.med_equip.TriggerScheduledJobResponse triggerScheduledJob(com.ywt.gapi.med_equip.TriggerScheduledJobRequest request){
            throw unimplementedMethodException(triggerScheduledJobMethod);
        }





        @Override
        public final ServiceDescriptor getServiceDescriptor() {
            return serviceDescriptor;
        }
        private RpcException unimplementedMethodException(StubMethodDescriptor methodDescriptor) {
            return TriRpcStatus.UNIMPLEMENTED.withDescription(String.format("Method %s is unimplemented",
                "/" + serviceDescriptor.getInterfaceName() + "/" + methodDescriptor.getMethodName())).asException();
        }
    }

}
